local beql, self = beql, beql
local L = AceLibrary("AceLocale-2.2"):new("beql")
local charlist = AceLibrary("Dewdrop-2.0")

beql.TimeSinceLastUpdate = 0
beql.AniType = ""

function beql:HistoryInit()
	local nowiam = UnitName("player").."-"..GetRealmName()
	local info = {
		type = 'group',
		args = {},
	}
	local i = 0
	charlist.value = nowiam
	HistoryCharacterList:SetText(string.sub(nowiam,0,string.find(nowiam,"-")-1))	
	for k, v in pairs (beql.db.profile.QuestHistory) do 
		i = i +1
		info.args[i] = {
			type = 'toggle',
			name = k,
			desc = k,
			get = function() if charlist.value == k then return true else return false end end,
			set = function() charlist.value = k HistoryCharacterList:SetText(string.sub(k,0,string.find(k,"-")-1)) end,
		}
	end
	charlist:Register(HistoryCharacterList, 'children', function()
	 charlist:FeedAceOptionsTable(info) 
	end)
end


function beql:HistoryCharListClick()
	if charlist:IsOpen() then
		charlist:Close()
	else
		charlist:Open(HistoryCharacterList)
	end
end

function beql:HistoryCharListSelect(k)
	charlist.value = k
	HistoryCharacterList:SetText(i,k)
	
end
-----

function beql:HistoryToggle()
	if beql.AniType ~= "" then return end
	if beqlHistoryFrame:IsShown() then
		beqlHistoryFrame:SetAlpha(1)
		beqlHistoryFrame:SetScale(1)
		beql.AniType = "FadeIn"
	else
		beqlHistoryFrame:Show()	
		beqlHistoryFrame:SetScale(0.01)
		beqlHistoryFrame:SetAlpha(0)
		beql.AniType = "FadeOut"
	end
end

function beql:HistoryAnimate(elapsed)

	if beql.AniType ~= "FadeIn" and beql.AniType ~= "FadeOut" then
		return
	end

	local alpha = 0
	local scale = 0

	beql.TimeSinceLastUpdate = beql.TimeSinceLastUpdate + elapsed

	if (beql.TimeSinceLastUpdate > 0.01) then
	
		if beql.AniType ~= "FadeIn" then
			alpha = beqlHistoryFrame:GetAlpha()
			alpha = alpha + 0.05
			scale = beqlHistoryFrame:GetScale()
			scale = scale + 0.05
			beqlHistoryFrame:SetAlpha(alpha)
			if scale > 1 then scale = 1 end
			beqlHistoryFrame:SetScale(scale)
			if alpha == 1 or alpha > 1 then
				beqlHistoryFrame:SetAlpha(1)
				beqlHistoryFrame:SetScale(1)
				beqlHistoryFrame:Show()
				beql.AniType = ""
			end
		else
			alpha = beqlHistoryFrame:GetAlpha()
			alpha = alpha - 0.05
			scale = beqlHistoryFrame:GetScale()
			scale = scale - 0.05			
			beqlHistoryFrame:SetAlpha(alpha)
			if scale < 0.01 then scale = 0.01 end
			beqlHistoryFrame:SetScale(scale)			
			if alpha == 0 or alpha < 0 then
				beqlHistoryFrame:SetAlpha(0)
				beqlHistoryFrame:SetScale(0.01)			
				beqlHistoryFrame:Hide()
				beql.AniType = ""
			end
		end

		beql.TimeSinceLastUpdate = 0
	end

end

function beql:HistoryScanLog()
	local nowiam = UnitName("player").."-"..GetRealmName()
	local zone
	local questid
	local qtitle, qlevel, qtag
	
	if beql.db.profile.QuestHistory[nowiam] == nil then
		beql.db.profile.QuestHistory[nowiam] = {} 
	end
	
	-- DB
		-- Char-Server
			-- Zone
				-- QuestName
					-- QuestID
					-- QLevel
					-- IsDaily -
					-- Tag
					-- Start Date
					-- Complete Date
					-- Start Pos
					-- Complete Pos
	
	for i, zone in beqlQ:IterZones() do 
		if beql.db.profile.QuestHistory[nowiam][zone] == nil then
			beql.db.profile.QuestHistory[nowiam][zone] = {}
		end
		for i, questid in beqlQ:QuestsByZone(zone) do 
			qtitle, qlevel, qtag = beqlQ:GetQuestById(questid)
			if beql.db.profile.QuestHistory[nowiam][zone][qtitle] == nil then
				beql.db.profile.QuestHistory[nowiam][zone][qtitle] = {}
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Level = qlevel
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].StartDate = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].StartPos = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Tag = qtag
				if qtag == "y" then 
					beql.db.profile.QuestHistory[nowiam][zone][qtitle].Daily = true
				else
					beql.db.profile.QuestHistory[nowiam][zone][qtitle].Daily = false
				end
			end
		end
	end
end

function beql:HistoryUpdate()
	
end